Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/HeuristicLab.Problems.VariableVectorClassification-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/HeuristicLab.Problems.VariableVectorClassification-3.3.csproj	(revision 9226)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/HeuristicLab.Problems.VariableVectorClassification-3.3.csproj	(revision 9226)
@@ -0,0 +1,116 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Problems.VariableVectorClassification</RootNamespace>
+    <AssemblyName>HeuristicLab.Problems.VariableVectorClassification-3.3</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.Collections-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Collections-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Common-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Data-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Data-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Operators-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Operators-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimization-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Optimization-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Parameters-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Parameters-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Persistence-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Problems.Instances-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="VariableVectorClassificationProblem.cs" />
+    <Compile Include="VariableVectorClassificationProblemData.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Plugin.cs" />
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.ConditionActionEncoding\3.3\HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj">
+      <Project>{422FB262-0845-4969-8D16-12F057AA90B1}</Project>
+      <Name>HeuristicLab.Encodings.ConditionActionEncoding-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.VariableVector\3.3\HeuristicLab.Encodings.VariableVector-3.3.csproj">
+      <Project>{7C116F48-7218-4105-BD6E-EE868E2D4823}</Project>
+      <Name>HeuristicLab.Encodings.VariableVector-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.ConditionActionClassification\3.3\HeuristicLab.Problems.ConditionActionClassification-3.3.csproj">
+      <Project>{EA51D441-F6A3-41E1-9993-A2488E93C222}</Project>
+      <Name>HeuristicLab.Problems.ConditionActionClassification-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj">
+      <Project>{DF87C13E-A889-46FF-8153-66DCAA8C5674}</Project>
+      <Name>HeuristicLab.Problems.DataAnalysis-3.4</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/Plugin.cs.frame
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/Plugin.cs.frame	(revision 9226)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/Plugin.cs.frame	(revision 9226)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Problems.VariableVectorClassification {
+  [Plugin("HeuristicLab.Problems.ConditionActionClassification", "3.3.7.$WCREV$")]
+  [PluginFile("HeuristicLab.Problems.VariableVectorClassification-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  public class HeuristicLabProblemsVariableVectorClassificationPlugin : PluginBase {
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/Properties/AssemblyInfo.cs.frame	(revision 9226)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/Properties/AssemblyInfo.cs.frame	(revision 9226)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Problems.VariableVectorClassification-3.3")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HEAL")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("15696931-c308-48bc-864e-08c7e5c90bfc")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.7.9194")]
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/VariableVectorClassificationProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/VariableVectorClassificationProblem.cs	(revision 9226)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/VariableVectorClassificationProblem.cs	(revision 9226)
@@ -0,0 +1,173 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Encodings.VariableVector;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.ConditionActionClassification;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.CombinedIntegerVectorClassification {
+  [StorableClass]
+  public class VariableVectorClassificationProblem : ConditionActionClassificationProblem<UniformRandomVariableVectorCreator,
+                                                            VariableVectorActionComparer,
+                                                            VariableVectorClassificationProblemData> {
+    public override string ChildName {
+      get { return "VariableVector"; }
+    }
+
+    #region parameter properties
+    private IFixedValueParameter<ItemSet<VariableVectorAction>> PossibleActionsConcreteClassParameter {
+      get { return (IFixedValueParameter<ItemSet<VariableVectorAction>>)Parameters["PossibleActionsConcreteClass"]; }
+    }
+    public override IFixedValueParameter<VariableVectorActionComparer> ClassifierComparerParameter {
+      get { return (IFixedValueParameter<VariableVectorActionComparer>)Parameters["ClassifierComparer"]; }
+    }
+    #endregion
+
+    #region properties
+    public new VariableVectorClassificationProblemData ProblemData {
+      get { return ProblemDataParameter.Value; }
+      protected set {
+        ProblemDataParameter.Value = value;
+        if (value != null) {
+          SetProblemDataSpecificParameters();
+        }
+      }
+    }
+
+    public ItemSet<VariableVectorAction> PossibleActionsConcreteClass {
+      get { return PossibleActionsConcreteClassParameter.Value; }
+    }
+    public IClassifierComparer ClassifierComparer {
+      get { return ClassifierComparerParameter.Value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected VariableVectorClassificationProblem(bool deserializing) : base(deserializing) { }
+    protected VariableVectorClassificationProblem(VariableVectorClassificationProblem original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVectorClassificationProblem(this, cloner);
+    }
+
+    public VariableVectorClassificationProblem() :
+      this(new VariableVectorClassificationProblemData(new Dataset(ConditionActionClassificationProblemData.defaultVariableNames, ConditionActionClassificationProblemData.defaultData),
+        ConditionActionClassificationProblemData.defaultVariableNames.Take(ConditionActionClassificationProblemData.defaultVariableNames.Length - 1), ConditionActionClassificationProblemData.defaultVariableNames.Last().ToEnumerable()),
+        new XCSEvaluator(), new UniformRandomVariableVectorCreator(), new VariableVectorCoveringCreator()) {
+    }
+
+    public VariableVectorClassificationProblem(VariableVectorClassificationProblemData problemData, XCSEvaluator evaluator, UniformRandomVariableVectorCreator solutionCreator, IVariableVectorCoveringCreator coveringSolutionCreator)
+      : base(problemData, evaluator, solutionCreator, coveringSolutionCreator) {
+      Parameters.Add(new FixedValueParameter<VariableVectorActionComparer>("ClassifierComparer", new VariableVectorActionComparer()));
+      Parameters.Add(new FixedValueParameter<ItemSet<IAction>>("PossibleActions", new ItemSet<IAction>(ClassifierComparer)));
+      Parameters.Add(new FixedValueParameter<ItemSet<VariableVectorAction>>("PossibleActionsConcreteClass", new ItemSet<VariableVectorAction>(ClassifierComparer)));
+
+      coveringSolutionCreator.SampleVariableVectorParameter.Value = problemData.SampleVariableVectorParameter.Value;
+
+      SetProblemDataSpecificParameters();
+
+      InitializeOperators();
+
+      problemData.Changed += new System.EventHandler(problemData_Changed);
+    }
+
+    private void problemData_Changed(object sender, System.EventArgs e) {
+      SetProblemDataSpecificParameters();
+    }
+
+    private void SetProblemDataSpecificParameters() {
+      SolutionCreator.SampleVariableVectorParameter.Value = ProblemData.SampleVariableVectorParameter.Value;
+      SolutionCreator.VariableVectorParameter.ActualName = ChildName;
+      SolutionCreator.SpreadPercentageParameter.Value = ProblemData.SpreadPercentageParameter.Value;
+
+      SetPossibleActions();
+    }
+
+    private void InitializeOperators() {
+      Operators.AddRange(ApplicationManager.Manager.GetInstances<IVariableVectorCrossover>());
+      Operators.AddRange(AddManipulators());
+
+      ParameterizeOperators();
+    }
+
+    private IEnumerable<IManipulator> AddManipulators() {
+      var manipulator = new UniformSomePositionManipulator();
+      manipulator.ChildParameter.ActualName = ChildName;
+      manipulator.FetchedInputParameter.ActualName = ClassifierFetcher.CurrentInputToMatchParameter.ActualName;
+      manipulator.PossibleActionsParameter.ActualName = PossibleActionsConcreteClassParameter.Name;
+      return new List<IManipulator>() { manipulator };
+    }
+
+    protected override void SetPossibleActions() {
+      var sampleAction = ProblemData.SampleVariableVector.Action;
+      var actionKeys = sampleAction.Order;
+      var actionsEnumeratorList = sampleAction.ToDictionary(x => x.Key, y => y.Value.GetAllPossibleActions().ToList());
+      int[] curPos = new int[actionsEnumeratorList.Count];
+      //initialize curPos
+      for (int i = 0; i < curPos.Length; i++) {
+        curPos[i] = 0;
+      }
+      bool done = false;
+      PossibleActions.Clear();
+      PossibleActionsConcreteClass.Clear();
+      VariableVectorAction curAction;
+      int cur;
+      while (!done) {
+        curAction = sampleAction.GetEmptyCopy();
+        cur = 0;
+        foreach (var key in actionKeys) {
+          curAction[key].SetTo(actionsEnumeratorList[key][curPos[cur]]);
+          cur++;
+        }
+        PossibleActions.Add(curAction);
+        PossibleActionsConcreteClass.Add(curAction);
+        done = MoveNext(actionsEnumeratorList, curPos, actionKeys);
+      }
+      ThetaMinimalNumberOfActions.Value = PossibleActions.Count;
+    }
+
+    private bool MoveNext(Dictionary<string, List<string>> actionsEnumeratorList, int[] curPos, IEnumerable<string> order) {
+      int cur = 0;
+      bool done = true;
+      foreach (var key in order) {
+        if (curPos[cur] + 1 < actionsEnumeratorList[key].Count) {
+          curPos[cur]++;
+          done = false;
+          break;
+        } else {
+          curPos[cur] = 0;
+        }
+        cur++;
+      }
+      return done;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/VariableVectorClassificationProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/VariableVectorClassificationProblemData.cs	(revision 9226)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.VariableVectorClassification/3.3/VariableVectorClassificationProblemData.cs	(revision 9226)
@@ -0,0 +1,130 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Encodings.VariableVector;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.ConditionActionClassification;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.CombinedIntegerVectorClassification {
+  [StorableClass]
+  [Item("CombinedIntegerVectorClassificationProblemData", "A problem data for LCS.")]
+  public class VariableVectorClassificationProblemData : ConditionActionClassificationProblemData {
+
+    #region parameter properites
+    public IFixedValueParameter<VariableVector> SampleVariableVectorParameter {
+      get { return (IFixedValueParameter<VariableVector>)Parameters["SampleVariableVector"]; }
+    }
+    public IFixedValueParameter<PercentValue> SpreadPercentageParameter {
+      get { return (IFixedValueParameter<PercentValue>)Parameters["SpreadPercentage"]; }
+    }
+    #endregion
+
+    #region properties
+    public VariableVector SampleVariableVector {
+      get { return SampleVariableVectorParameter.Value; }
+    }
+    public PercentValue SpreadPercentage {
+      get { return SpreadPercentageParameter.Value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected VariableVectorClassificationProblemData(bool deserializing) : base(deserializing) { }
+    protected VariableVectorClassificationProblemData(VariableVectorClassificationProblemData original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVectorClassificationProblemData(this, cloner);
+    }
+
+    public VariableVectorClassificationProblemData(Dataset dataset, IEnumerable<string> allowedConditionVariables, IEnumerable<string> allowedActionVariables) :
+      base(dataset, allowedConditionVariables, allowedActionVariables) {
+
+
+      Parameters.Add(new FixedValueParameter<VariableVector>("SampleVariableVector", "", GenerateSampleVariableVector(dataset, allowedConditionVariables, allowedActionVariables)));
+      Parameters.Add(new FixedValueParameter<PercentValue>("SpreadPercentage", "", new PercentValue(0.5)));
+    }
+
+    private VariableVector GenerateSampleVariableVector(Dataset dataset, IEnumerable<string> allowedConditionVariables, IEnumerable<string> allowedActionVariables) {
+      var conditionVariables = GetVariablesOfDataSet(dataset, allowedConditionVariables);
+      var actionVariables = GetVariablesOfDataSet(dataset, allowedActionVariables);
+      if (actionVariables.Count() == 0 || !actionVariables.All(x => x is IActionVariable)) {
+        throw new ArgumentException("Action variable can not be empty and all action variables have to be of type int or string.");
+      }
+      return new VariableVector(conditionVariables, actionVariables);
+    }
+
+    private IEnumerable<Encodings.VariableVector.IVariable> GetVariablesOfDataSet(DataAnalysis.Dataset dataset, IEnumerable<string> allowedVariables) {
+      var variables = new List<HeuristicLab.Encodings.VariableVector.IVariable>();
+      foreach (var variableName in allowedVariables) {
+        var variableValues = dataset.GetValues(variableName);
+        HeuristicLab.Encodings.VariableVector.IVariable variable;
+        if (variableValues is List<string>) {
+          variable = new StringVariable(variableName, (variableValues as List<string>).Distinct());
+        } else if (variableValues is List<double>) {
+          var doubleValues = (variableValues as List<double>).Distinct();
+          if (doubleValues.All(x => x % 1 == 0)) {
+            variable = new IntVariable(variableName, doubleValues.Select(x => Convert.ToInt32(x)));
+          } else {
+            variable = new DoubleVariable(variableName, doubleValues);
+          }
+        } else {
+          throw new ArgumentException("There is no matching variable type for the values in the dataset");
+        }
+        variables.Add(variable);
+      }
+      return variables;
+    }
+
+    public override IInput FetchInput(int rowNumber) {
+      if (!fetchInputCache.ContainsKey(rowNumber)) {
+        VariableVectorInput input = new VariableVectorInput();
+        IEnumerable<string> variableNames = SampleVariableVector.Condition.Keys.Union(SampleVariableVector.Action.Keys);
+        foreach (var variableName in variableNames) {
+          input.Add(variableName, Dataset.GetValue(rowNumber, variableName));
+        }
+        fetchInputCache.Add(rowNumber, input);
+      }
+      return fetchInputCache[rowNumber];
+    }
+
+    protected IDictionary<int, IAction> fetchActionCache = new Dictionary<int, IAction>();
+    public override IAction FetchAction(int rowNumber) {
+      if (!fetchActionCache.ContainsKey(rowNumber)) {
+        var action = SampleVariableVector.Action.GetEmptyCopy();
+        foreach (var variableName in action.Keys) {
+          action[variableName].SetTo(Dataset.GetValue(rowNumber, variableName));
+        }
+        fetchActionCache.Add(rowNumber, action);
+      }
+      return fetchActionCache[rowNumber];
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/LearningClassifierSystem.sln
===================================================================
--- /branches/LearningClassifierSystems/LearningClassifierSystem.sln	(revision 9225)
+++ /branches/LearningClassifierSystems/LearningClassifierSystem.sln	(revision 9226)
@@ -18,9 +18,15 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.XCS.Views-3.3", "HeuristicLab.Problems.XCS.Views\3.3\HeuristicLab.Problems.XCS.Views-3.3.csproj", "{8FFB8E0F-BC17-4D72-AF0F-E67A22F8EDE5}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.Instances.ConditionActionClassification", "HeuristicLab.Problems.Instances.ConditionActionClassification\3.3\HeuristicLab.Problems.Instances.ConditionActionClassification.csproj", "{1CC7585E-DD22-41FA-869B-93DE41EA8936}"
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.Instances.ConditionActionClassification-3.3", "HeuristicLab.Problems.Instances.ConditionActionClassification\3.3\HeuristicLab.Problems.Instances.ConditionActionClassification-3.3.csproj", "{1CC7585E-DD22-41FA-869B-93DE41EA8936}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Core-3.3", "HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj", "{C36BD924-A541-4A00-AFA8-41701378DDC5}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Encodings.VariableVector-3.3", "HeuristicLab.Encodings.VariableVector\3.3\HeuristicLab.Encodings.VariableVector-3.3.csproj", "{7C116F48-7218-4105-BD6E-EE868E2D4823}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.CombinedIntegerVectorClassification-3.3", "HeuristicLab.Problems.CombinedIntegerVectorClassification\3.3\HeuristicLab.Problems.CombinedIntegerVectorClassification-3.3.csproj", "{E8D42226-3FAF-49AD-91E9-D48A422A1BD0}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.VariableVectorClassification-3.3", "HeuristicLab.Problems.VariableVectorClassification\3.3\HeuristicLab.Problems.VariableVectorClassification-3.3.csproj", "{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis-3.4", "HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj", "{DF87C13E-A889-46FF-8153-66DCAA8C5674}"
 EndProject
 Global
@@ -106,4 +112,32 @@
 		{7C116F48-7218-4105-BD6E-EE868E2D4823}.Release|x64.ActiveCfg = Release|Any CPU
 		{7C116F48-7218-4105-BD6E-EE868E2D4823}.Release|x86.ActiveCfg = Release|Any CPU
+		{E8D42226-3FAF-49AD-91E9-D48A422A1BD0}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{E8D42226-3FAF-49AD-91E9-D48A422A1BD0}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{E8D42226-3FAF-49AD-91E9-D48A422A1BD0}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{E8D42226-3FAF-49AD-91E9-D48A422A1BD0}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{E8D42226-3FAF-49AD-91E9-D48A422A1BD0}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{E8D42226-3FAF-49AD-91E9-D48A422A1BD0}.Release|Any CPU.Build.0 = Release|Any CPU
+		{E8D42226-3FAF-49AD-91E9-D48A422A1BD0}.Release|x64.ActiveCfg = Release|Any CPU
+		{E8D42226-3FAF-49AD-91E9-D48A422A1BD0}.Release|x86.ActiveCfg = Release|Any CPU
+		{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}.Release|Any CPU.Build.0 = Release|Any CPU
+		{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}.Release|x64.ActiveCfg = Release|Any CPU
+		{4833BCCD-C7FB-40AB-ABE6-31A8A1FAA3CC}.Release|x86.ActiveCfg = Release|Any CPU
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Debug|x64.ActiveCfg = Debug|x64
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Debug|x64.Build.0 = Debug|x64
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Debug|x86.ActiveCfg = Debug|x86
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Debug|x86.Build.0 = Debug|x86
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Release|Any CPU.Build.0 = Release|Any CPU
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Release|x64.ActiveCfg = Release|x64
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Release|x64.Build.0 = Release|x64
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Release|x86.ActiveCfg = Release|x86
+		{DF87C13E-A889-46FF-8153-66DCAA8C5674}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
